"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VersionInfo = void 0;
const design_ui_surfaces_menu_link_item_1 = require("@teambit/design.ui.surfaces.menu.link-item");
const design_ui_time_ago_1 = require("@teambit/design.ui.time-ago");
const component_ui_version_label_1 = require("@teambit/component.ui.version-label");
const react_1 = __importStar(require("react"));
const design_ui_avatar_1 = require("@teambit/design.ui.avatar");
const design_ui_styles_ellipsis_1 = require("@teambit/design.ui.styles.ellipsis");
const classnames_1 = __importDefault(require("classnames"));
const version_info_module_scss_1 = __importDefault(require("./version-info.module.scss"));
exports.VersionInfo = react_1.default.memo(react_1.default.forwardRef(_VersionInfo));
function _VersionInfo({ version, currentVersion, latestVersion, date, username, displayName, email, overrideVersionHref, showDetails, message, tag, profileImage, onVersionClicked, }, ref) {
    const isCurrent = version === currentVersion;
    const author = (0, react_1.useMemo)(() => {
        return {
            displayName: displayName !== null && displayName !== void 0 ? displayName : '',
            email,
            name: username !== null && username !== void 0 ? username : '',
            profileImage,
        };
    }, [displayName, email, username, profileImage]);
    const timestamp = (0, react_1.useMemo)(() => (date ? new Date(parseInt(date)).toString() : new Date().toString()), [date]);
    const currentVersionRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        var _a;
        if (isCurrent) {
            (_a = currentVersionRef.current) === null || _a === void 0 ? void 0 : _a.scrollIntoView({ block: 'nearest' });
        }
    }, [isCurrent]);
    const href = overrideVersionHref ? overrideVersionHref(version) : `?version=${version}`;
    const formattedVersion = (0, react_1.useMemo)(() => {
        return tag ? version : version.slice(0, 6);
    }, [tag, version]);
    const isLatest = version === latestVersion;
    return (react_1.default.createElement("div", { ref: ref || currentVersionRef, onClick: onVersionClicked },
        react_1.default.createElement(design_ui_surfaces_menu_link_item_1.MenuLinkItem, { active: isCurrent, href: href, className: version_info_module_scss_1.default.versionRow },
            react_1.default.createElement("div", { className: version_info_module_scss_1.default.version },
                react_1.default.createElement(design_ui_avatar_1.UserAvatar, { size: 24, account: author, className: version_info_module_scss_1.default.versionUserAvatar, showTooltip: true }),
                react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: (0, classnames_1.default)(version_info_module_scss_1.default.versionName) }, formattedVersion),
                isLatest && react_1.default.createElement(component_ui_version_label_1.VersionLabel, { status: "latest" }),
                react_1.default.createElement(CommitMessage, { message: message, showDetails: showDetails })),
            react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: version_info_module_scss_1.default.versionTimestamp },
                react_1.default.createElement(design_ui_time_ago_1.TimeAgo, { date: timestamp })))));
}
function CommitMessage({ message, showDetails }) {
    if (!showDetails)
        return null;
    if (!message || message === '')
        return react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: version_info_module_scss_1.default.emptyMessage }, "No commit message");
    return react_1.default.createElement(design_ui_styles_ellipsis_1.Ellipsis, { className: version_info_module_scss_1.default.commitMessage }, message);
}
//# sourceMappingURL=version-info.js.map